"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/use-snippet.ts
var use_snippet_exports = {};
__export(use_snippet_exports, {
  useSnippet: () => useSnippet
});
module.exports = __toCommonJS(use_snippet_exports);
var import_theme = require("@nextui-org/theme");
var import_system = require("@nextui-org/system");
var import_dom_utils = require("@nextui-org/dom-utils");
var import_shared_utils = require("@nextui-org/shared-utils");
var import_use_clipboard = require("@nextui-org/use-clipboard");
var import_focus = require("@react-aria/focus");
var import_react = require("react");
var import_interactions = require("@react-aria/interactions");
var import_utils = require("@react-aria/utils");
function useSnippet(originalProps) {
  const [props, variantProps] = (0, import_system.mapPropsVariants)(originalProps, import_theme.snippet.variantKeys);
  const {
    ref,
    as,
    children,
    symbol = "$",
    classNames,
    timeout,
    copyIcon,
    checkIcon,
    disableCopy = false,
    disableTooltip = false,
    hideCopyButton = false,
    autoFocus = false,
    hideSymbol = false,
    onCopy: onCopyProp,
    tooltipProps = {
      offset: 15,
      delay: 1e3,
      content: "Copy to clipboard",
      variant: originalProps == null ? void 0 : originalProps.variant,
      color: originalProps == null ? void 0 : originalProps.color,
      isDisabled: disableCopy
    },
    className,
    ...otherProps
  } = props;
  const Component = as || "div";
  const domRef = (0, import_dom_utils.useDOMRef)(ref);
  const { copy, copied } = (0, import_use_clipboard.useClipboard)({ timeout });
  const isMultiLine = children && Array.isArray(children);
  const { isFocusVisible, isFocused, focusProps } = (0, import_focus.useFocusRing)({
    autoFocus
  });
  const slots = (0, import_react.useMemo)(
    () => (0, import_theme.snippet)({
      ...variantProps
    }),
    [...Object.values(variantProps)]
  );
  const symbolBefore = (0, import_react.useMemo)(() => {
    if (!symbol || typeof symbol !== "string")
      return symbol;
    const str = symbol.trim();
    return str ? `${str} ` : "";
  }, [symbol]);
  const baseStyles = (0, import_shared_utils.clsx)(classNames == null ? void 0 : classNames.base, className);
  const getSnippetProps = (0, import_react.useCallback)(
    () => ({
      className: slots.base({
        class: baseStyles
      }),
      ...otherProps
    }),
    [slots, baseStyles, isMultiLine, otherProps]
  );
  const onCopy = (0, import_react.useCallback)(() => {
    if (disableCopy) {
      return;
    }
    let value = "";
    if (typeof children === "string") {
      value = children;
    } else if (Array.isArray(children)) {
      value = children.join("\n");
    }
    copy(value);
    onCopyProp == null ? void 0 : onCopyProp(value);
  }, [copy, disableCopy, onCopyProp, children]);
  const { isPressed: isCopyPressed, pressProps: copyButtonPressProps } = (0, import_interactions.usePress)({
    isDisabled: disableCopy,
    onPress: onCopy
  });
  const getCopyButtonProps = (0, import_react.useCallback)(
    (props2 = {}) => ({
      ...(0, import_utils.mergeProps)(copyButtonPressProps, focusProps, props2),
      "data-focus": (0, import_shared_utils.dataAttr)(isFocused),
      "data-focus-visible": (0, import_shared_utils.dataAttr)(isFocusVisible),
      "data-pressed": (0, import_shared_utils.dataAttr)(isCopyPressed),
      className: slots.copy({
        class: (0, import_shared_utils.clsx)(disableCopy && "opacity-50 cursor-not-allowed", classNames == null ? void 0 : classNames.copy)
      })
    }),
    [
      slots,
      isCopyPressed,
      isFocusVisible,
      isFocused,
      disableCopy,
      classNames == null ? void 0 : classNames.copy,
      copyButtonPressProps,
      focusProps
    ]
  );
  return {
    Component,
    as,
    domRef,
    children,
    slots,
    classNames,
    copied,
    onCopy,
    copyIcon,
    checkIcon,
    symbolBefore,
    isMultiLine,
    isFocusVisible,
    hideCopyButton,
    disableCopy,
    disableTooltip,
    hideSymbol,
    tooltipProps,
    getSnippetProps,
    getCopyButtonProps
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  useSnippet
});
